Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/TableOperations/table-operations.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/TableOperations/table-operations.js	(revision 3287)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/TableOperations/table-operations.js	(working copy)
@@ -44,18 +44,42 @@
 	 */
 	configurePlugin : function (editor) {
 		
+		this.classesUrl = this.editorConfiguration.classesUrl;
 		this.buttonsConfiguration = this.editorConfiguration.buttons;
+		this.floatLeft = "float-left";
+		this.floatRight = "float-right";
+		this.floatDefault = "not set";
+		this.useHeaderClass = "thead";
+		if (this.buttonsConfiguration.table && this.buttonsConfiguration.table.properties) {
+			if (this.buttonsConfiguration.table.properties.float) {
+				var floatConfiguration = this.buttonsConfiguration.table.properties.float;
+				this.floatLeft = (floatConfiguration.left && floatConfiguration.left.useClass) ? floatConfiguration.left.useClass : "float-left";
+				this.floatRight = (floatConfiguration.right && floatConfiguration.right.useClass) ? floatConfiguration.right.useClass : "float-right";
+				this.floatDefault = (floatConfiguration.defaultValue) ?  floatConfiguration.defaultValue : "not set";
+			}
+			if (this.buttonsConfiguration.table.properties.headers && this.buttonsConfiguration.table.properties.headers.both 
+					&& this.buttonsConfiguration.table.properties.headers.both.useHeaderClass) {
+				this.useHeaderClass = this.buttonsConfiguration.table.properties.headers.both.useHeaderClass;
+			}
+		}
 		
+		if (this.buttonsConfiguration.blockstyle) {
+			this.tags = this.editorConfiguration.buttons.blockstyle.tags;
+		}
+		
+		this.tableParts = ["tfoot", "thead", "tbody"];
+		this.convertAlignment = { "not set" : "none", "left" : "JustifyLeft", "center" : "JustifyCenter", "right" : "JustifyRight", "justify" : "JustifyFull" };
+		
 		/*
 		 * Registering plugin "About" information
 		 */
 		var pluginInformation = {
-			version		: "3.7",
+			version		: "4.0",
 			developer	: "Mihai Bazon & Stanislas Rolland",
 			developerUrl	: "http://www.fructifor.ca/",
 			copyrightOwner	: "Mihai Bazon & Stanislas Rolland",
-			sponsor		: "Zapatec Inc. & Fructifor Inc.",
-			sponsorUrl	: "http://www.fructifor.ca/",
+			sponsor		: this.localize("Technische Universitat Ilmenau") + " & Zapatec Inc.",
+			sponsorUrl	: "http://www.tu-ilmenau.de/",
 			license		: "GPL"
 		};
 		this.registerPluginInformation(pluginInformation);
@@ -89,11 +113,13 @@
 		["InsertTable",		null,				"table"],
 		["toggle-borders",	null, 				"toggleborders"],
 		["table-prop",		"table",			"tableproperties"],
+		["table-restyle",	"table",			"tablerestyle"],
 		["row-prop",		"tr",				"rowproperties"],
 		["row-insert-above",	"tr",				"rowinsertabove"],
 		["row-insert-under",	"tr",				"rowinsertunder"],
 		["row-delete",		"tr",				"rowdelete"],
 		["row-split",		"td,th[rowSpan!=1]",		"rowsplit"],
+		["col-prop",		"td,th",			"columnproperties"],
 		["col-insert-before",	"td,th",			"columninsertbefore"],
 		["col-insert-after",	"td,th",			"columninsertafter"],
 		["col-delete",		"td,th",			"columndelete"],
@@ -106,21 +132,18 @@
 		["cell-split",		"td,th[colSpan!=1,rowSpan!=1]",	"cellsplit"]
 	],
 	
-	/************************
-	 * UTILITIES
-	 ************************/
 	/*
-	 * Retrieve the closest element having the specified tagName in the list of
+	 * Retrieve the closest element having the specified nodeName in the list of
 	 * ancestors of the current selection/caret.
 	 */
-	getClosest : function (tagName) {
+	getClosest : function (nodeName) {
 		var editor = this.editor;
 		var ancestors = editor.getAllAncestors();
 		var ret = null;
-		tagName = ("" + tagName).toLowerCase();
+		nodeName = ("" + nodeName).toLowerCase();
 		for (var i=0; i < ancestors.length; ++i) {
 			var el = ancestors[i];
-			if (el.tagName.toLowerCase() == tagName) {
+			if (el.nodeName.toLowerCase() == nodeName) {
 				ret = el;
 				break;
 			}
@@ -129,21 +152,209 @@
 	},
 	
 	/*
-	 * Open the table properties dialog.
+	 * Open the table properties dialogue
 	 */
-	dialogTableProperties : function () {
-			// retrieve existing values
-		var table = this.getClosest("table");
-		var tablePropertiesInitFunctRef = TableOperations.tablePropertiesInit(table);
-		var tablePropertiesUpdateFunctRef = TableOperations.tablePropertiesUpdate(table);
-		var dialog = new PopupWin(this.editor, this.localize("Table Properties"), tablePropertiesUpdateFunctRef, tablePropertiesInitFunctRef, 570, 600);
+	dialogTableProperties : function (buttonId) {
+		var tablePropertiesInitFunctRef = this.makeFunctionReference("tablePropertiesInit");
+		var insert = (buttonId === "InsertTable");
+		var arguments = {
+			title 		: (insert ? "Insert Table" : "Table Properties"),
+			initialize	: tablePropertiesInitFunctRef,
+			element		: (insert ? null : this.getClosest("table"))
+		};
+		var dimensions = {
+			width	: 820,
+			height	: insert ? 600 : 630
+		};
+		this.dialog = this.openDialog((insert ? "InsertTable" : "table-prop"), "", "tablePropertiesUpdate", arguments, dimensions);
 	},
 	
 	/*
-	 * Open the row/cell properties dialog.
-	 * This function requires the file PopupWin to be loaded.
+	 * Initialize the table insertion or table properties dialog
 	 */
-	dialogRowCellProperties : function (cell) {
+	tablePropertiesInit : function(dialog) {
+		var doc = dialog.document;
+		var content = dialog.content;
+		var table = dialog.arguments.element;
+		this.removedFieldsets = this.buttonsConfiguration[table?"tableproperties":"table"].removeFieldsets ? this.buttonsConfiguration[table?"tableproperties":"table"].removeFieldsets : "";
+		this.properties = this.buttonsConfiguration.table.properties;
+		this.removedProperties = (this.properties && this.properties.removed) ? this.properties.removed : "";
+		TableOperations.buildTitle(doc, content, dialog.arguments.title);
+		TableOperations.insertSpace(doc, content);
+		if (this.removedFieldsets.indexOf("description") == -1) {
+			TableOperations.buildDescriptionFieldset(doc, table, content, "floating");
+		}
+		if (this.removedFieldsets.indexOf("spacing") == -1) TableOperations.buildSpacingFieldset(doc, table, content);
+		TableOperations.insertSpace(doc, content);
+		this.buildSizeAndHeadersFieldset(doc, table, content, "floating");
+		if (this.removedFieldsets.indexOf("style") == -1 && dialog.editor.config.customSelects.BlockStyle) {
+			var blockStyle = dialog.editor.plugins.BlockStyle.instance;
+			if (blockStyle && blockStyle.cssLoaded) {
+				TableOperations.buildStylingFieldset(doc, this.editor, table, content);
+				TableOperations.insertSpace(doc, content);
+			}
+		}
+		if (this.removedFieldsets.indexOf("layout") == -1) this.buildLayoutFieldset(doc, table, content, "floating");
+		if (this.removedFieldsets.indexOf("alignment") == -1) this.buildAlignmentFieldset(doc, table, content);
+		TableOperations.insertSpace(doc, content);
+		if (this.removedFieldsets.indexOf("borders") == -1) this.buildBordersFieldset(dialog.dialogWindow, doc, dialog.editor, table, content);
+		if (this.removedFieldsets.indexOf("color") == -1) TableOperations.buildColorsFieldset(dialog.dialogWindow, doc, dialog.editor, table, content);
+		dialog.addButtons("ok", "cancel");
+	},
+	
+	/*
+	 * Insert the table or update the table properties and close the dialogue
+	 */
+	tablePropertiesUpdate : function(dialog, params) {
+		if (this.buttonsConfiguration.table.properties && this.buttonsConfiguration.table.properties.required) {
+			if (this.buttonsConfiguration.table.properties.required.indexOf("captionOrSummary") != -1) {
+				if (!/\S/.test(params.f_caption) && !/\S/.test(params.f_summary)) {
+					dialog.dialogWindow.alert(this.localize("captionOrSummary" + "-required"));
+					var el = dialog.document.getElementById("f_caption");
+					el.focus();
+					return false;
+				}
+			} else {
+				var required = { "f_caption": "caption", "f_summary": "summary" };
+				for (var i in required) {
+					if (required.hasOwnProperty(i)) {
+						var el = dialog.document.getElementById(i);
+						if (!el.value && this.buttonsConfiguration.table.properties.required.indexOf(required[i]) != -1) {
+							dialog.dialogWindow.alert(this.localize(required[i] + "-required"));
+							el.focus();
+							return false;
+						}
+					}
+				}
+			}
+		}
+		var doc = dialog.editor._doc;
+		if (dialog.buttonId === "InsertTable") {
+			var required = { "f_rows": "You must enter a number of rows", "f_cols": "You must enter a number of columns" };
+			for (var i in required) {
+				if (required.hasOwnProperty(i)) {
+					var el = dialog.document.getElementById(i);
+					if (!el.value) {
+						dialog.dialogWindow.alert(this.localize(required[i]));
+						el.focus();
+						return false;
+					}
+				}
+			}
+			var table = doc.createElement("table");
+			var tbody = doc.createElement("tbody");
+			table.appendChild(tbody);
+			for (var i = params.f_rows; --i >= 0;) {
+				var tr = doc.createElement("tr");
+				tbody.appendChild(tr);
+				for (var j = params.f_cols; --j >= 0;) {
+					var td = doc.createElement("td");
+					tr.appendChild(td);
+				}
+			}
+		} else {
+			var table = dialog.arguments.element;
+		}
+		table = this.setHeaders(table, params);
+		table = this.processStyle(table, params);
+		table.removeAttribute("border");
+		for (var i in params) {
+			if (params.hasOwnProperty(i)) {
+				var val = params[i];
+				switch (i) {
+				    case "f_caption":
+					if (/\S/.test(val)) {
+						// contains non white-space characters
+						var caption = table.getElementsByTagName("caption");
+						if (caption) {
+							caption = caption[0];
+						}
+						if (!caption) {
+							var caption = doc.createElement("caption");
+							table.appendChild(caption);
+						}
+						caption.innerHTML = val;
+					} else {
+						// delete the caption if found
+						if (table.caption) table.deleteCaption();
+					}
+					break;
+				    case "f_summary":
+					table.summary = val;
+					break;
+				    case "f_width":
+					table.style.width = ("" + val) + params.f_unit;
+					break;
+				    case "f_align":
+					table.align = val;
+					break;
+				    case "f_spacing":
+					table.cellSpacing = val;
+					break;
+				    case "f_padding":
+					table.cellPadding = val;
+					break;
+				    case "f_frames":
+					table.frame = (val != "not set") ? val : "";
+					break;
+				    case "f_rules":
+					if (val != "not set") table.rules = val;
+						else table.removeAttribute("rules");
+					break;
+				    case "f_st_float":
+					switch (val) {
+					    case "not set":
+						HTMLArea._removeClass(table, this.floatRight);
+						HTMLArea._removeClass(table, this.floatLeft);
+						break;
+					    case "right":
+						HTMLArea._removeClass(table, this.floatLeft);
+						HTMLArea._addClass(table, this.floatRight);
+						break;
+					    case "left":
+						HTMLArea._removeClass(table, this.floatRight);
+						HTMLArea._addClass(table, this.floatLeft);
+						break;
+					}
+					break;
+				    case "f_st_textAlign":
+					if (this.editor.plugins.BlockElements) {
+						this.editor.plugins.BlockElements.instance.toggleAlignmentClass(table, this.convertAlignment[val]);
+						table.style.textAlign = "";
+					}
+					break;
+				    case "f_class":
+				    case "f_class_tbody":
+				    case "f_class_thead":
+				    case "f_class_tfoot":
+					var tpart = table;
+					if (i.length > 7) tpart = table.getElementsByTagName(i.substring(8,13))[0];
+					if (tpart) {
+						this.editor.plugins.BlockStyle.instance.applyClassChange(tpart, val);
+					}
+					break;
+				}
+			}
+		}
+		if (dialog.buttonId === "InsertTable") {
+			this.editor.insertNodeAtSelection(table);
+			if (HTMLArea.is_gecko) {
+				this.editor.selectNodeContents(table.rows[0].cells[0], true);
+			}
+			if (this.buttonsConfiguration.toggleborders && this.buttonsConfiguration.toggleborders.setOnTableCreation) {
+				this.toggleBorders(true);
+			} else if (HTMLArea.is_gecko && !HTMLArea.is_safari && !HTMLArea.is_opera) {
+					// otherwise the cells are 2 pixels high..
+				this.editor.setMode("wysiwyg");
+			}
+		}
+		dialog.close();
+	},
+	
+	/*
+	 * Open the row/column/cell properties dialogue
+	 */
+	dialogRowCellProperties : function (cell, column) {
 			// retrieve existing values
 		if (cell) {
 			var element = this.getClosest("td");
@@ -151,14 +362,122 @@
 		} else {
 			var element = this.getClosest("tr");
 		}
-		if(element) {
-			var rowCellPropertiesInitFunctRef = TableOperations.rowCellPropertiesInit(element, cell);
-			var rowCellPropertiesUpdateFunctRef = TableOperations.rowCellPropertiesUpdate(element);
-			var dialog = new PopupWin(this.editor, this.localize(cell ? "Cell Properties" : "Row Properties"), rowCellPropertiesUpdateFunctRef, rowCellPropertiesInitFunctRef, 700, 425);
+		if (element) {
+			var rowCellPropertiesInitFunctRef = this.makeFunctionReference("rowCellPropertiesInit");
+			var arguments = {
+				title 		: (cell ? (column ? "Column Properties" : "Cell Properties") : "Row Properties"),
+				initialize	: rowCellPropertiesInitFunctRef,
+				element		: element,
+				cell		: cell,
+				column		: column
+			};
+			this.dialog = this.openDialog(cell ? (column ? "col-prop" : "cell-prop") :"row-prop", "", "rowCellPropertiesUpdate", arguments, { width : 830, height : 425 });
 		}
 	},
 	
 	/*
+	 * Initialize the row/column/cell properties dialogue
+	 */
+	rowCellPropertiesInit : function(dialog) {
+		var doc = dialog.document;
+		var content = dialog.content;
+		var element = dialog.arguments.element;
+		var cell = dialog.arguments.cell;
+		var column = dialog.arguments.column;
+		this.removedFieldsets = this.buttonsConfiguration[cell?(column?"columnproperties":"cellproperties"):"rowproperties"].removeFieldsets ? this.buttonsConfiguration[cell?(column?"columnproperties":"cellproperties"):"rowproperties"].removeFieldsets : "";
+		this.properties = this.buttonsConfiguration[(cell ||column)?"cellproperties":"rowproperties"].properties;
+		this.removedProperties = (this.properties && this.properties.removed) ? this.properties.removed : "";
+		TableOperations.buildTitle(doc, content, (cell ? (column ? "Column Properties" : "Cell Properties") : "Row Properties"));
+		TableOperations.insertSpace(doc, content);
+		if (column) {
+			if (this.removedFieldsets.indexOf("columntype") == -1) TableOperations.buildCellTypeFieldset(doc, dialog.editor, element, content, true);
+		} else if (cell) {
+			if (this.removedFieldsets.indexOf("celltype") == -1) TableOperations.buildCellTypeFieldset(doc, dialog.editor, element, content, false);
+		} else {
+			if (this.removedFieldsets.indexOf("rowgroup") == -1) TableOperations.buildRowGroupFieldset(dialog.dialogWindow, doc, dialog.editor, element, content);
+		}
+		if (this.removedFieldsets.indexOf("style") == -1 && this.editor.config.customSelects.BlockStyle) {
+			var blockStyle = this.editor.plugins.BlockStyle.instance;
+			if (blockStyle && blockStyle.cssLoaded) {
+				TableOperations.buildStylingFieldset(doc, this.editor, element, content);
+				TableOperations.insertSpace(doc, content);
+			} else {
+				TableOperations.insertSpace(doc, content);
+			}
+		} else {
+			TableOperations.insertSpace(doc, content);
+		}
+		if (this.removedFieldsets.indexOf("layout") == -1) this.buildLayoutFieldset(doc, element, content, "floating");
+		if (this.removedFieldsets.indexOf("alignment") == -1) this.buildAlignmentFieldset(doc, element, content);
+		if (this.removedFieldsets.indexOf("borders") == -1) this.buildBordersFieldset(dialog.dialogWindow, doc, dialog.editor, element, content);
+		if (this.removedFieldsets.indexOf("color") == -1) TableOperations.buildColorsFieldset(dialog.dialogWindow, doc, dialog.editor, element, content);
+		dialog.addButtons("ok", "cancel");
+	},
+	
+	/*
+	 * Update the row/column/cell properties
+	 */
+	rowCellPropertiesUpdate : function(dialog, params) {
+		var element = dialog.arguments.element;
+		var cell = dialog.arguments.cell;
+		var column = dialog.arguments.column;
+		var section = (cell || column) ? element.parentNode.parentNode : element.parentNode;
+		var table = section.parentNode;
+		var elements = new Array();
+		if (column) {
+			elements = this.getColumnCells(dialog.arguments.element);
+		} else {
+			elements.push(dialog.arguments.element);
+		}
+		for (var k = elements.length; --k >= 0;) {
+			var element = elements[k];
+			element = this.processStyle(element, params);
+			for (var i in params) {
+				var val = params[i];
+				switch (i) {
+				    case "f_cell_type":
+					if (val.substring(0,2) != element.nodeName.toLowerCase()) {
+						element = this.remapCell(element, val.substring(0,2));
+						this.editor.selectNodeContents(element, true);
+					}
+					if (val.substring(2,10) != element.scope) {
+						element.scope = val.substring(2,10);
+					}
+					break;
+				    case "f_rowgroup":
+					var nodeName = section.nodeName.toLowerCase();
+					if (val != nodeName) {
+						var newSection = table.getElementsByTagName(val)[0];
+						if (!newSection) var newSection = table.insertBefore(dialog.editor._doc.createElement(val), table.getElementsByTagName("tbody")[0]);
+						if (nodeName == "thead" && val == "tbody") var newElement = newSection.insertBefore(element, newSection.firstChild);
+							else var newElement = newSection.appendChild(element);
+						if (!section.hasChildNodes()) table.removeChild(section);
+					}
+					if (params.f_convertCells) {
+						if (val == "thead") {
+							this.remapRowCells(element, "th");
+						} else {
+							this.remapRowCells(element, "td");
+						}
+					}
+					break;
+				    case "f_st_textAlign":
+					if (this.editor.plugins.BlockElements) {
+						this.editor.plugins.BlockElements.instance.toggleAlignmentClass(element, this.convertAlignment[val]);
+						element.style.textAlign = "";
+					}
+					break;
+				    case "f_class":
+					this.editor.plugins.BlockStyle.instance.applyClassChange(element, val);
+					break;
+				}
+			}
+		}
+		this.reStyleTable(table);
+		dialog.close();
+	},
+	
+	/*
 	 * This function gets called when a Table Operations button was pressed.
 	 *
 	 * @param	object		editor: the editor instance
@@ -194,7 +513,7 @@
 		function splitRow(td) {
 			var n = parseInt("" + td.rowSpan);
 			var colSpan = td.colSpan;
-			var tagName = td.tagName.toLowerCase();
+			var nodeName = td.nodeName.toLowerCase();
 			td.rowSpan = 1;
 			var tr = td.parentNode;
 			var sectionRowIndex = tr.sectionRowIndex;
@@ -204,7 +523,7 @@
 				tr = rows[++sectionRowIndex];
 					// Last row
 				if (!tr) tr = td.parentNode.parentNode.appendChild(editor._doc.createElement("tr"));
-				var otd = editor._doc.createElement(tagName);
+				var otd = editor._doc.createElement(nodeName);
 				otd.colSpan = colSpan;
 				otd.innerHTML = mozbr;
 				tr.insertBefore(otd, tr.cells[index]);
@@ -213,12 +532,12 @@
 	
 		function splitCol(td) {
 			var nc = parseInt("" + td.colSpan);
-			var tagName = td.tagName.toLowerCase();
+			var nodeName = td.nodeName.toLowerCase();
 			td.colSpan = 1;
 			var tr = td.parentNode;
 			var ref = td.nextSibling;
 			while (--nc > 0) {
-				var otd = editor._doc.createElement(tagName);
+				var otd = editor._doc.createElement(nodeName);
 				otd.rowSpan = td.rowSpan;
 				otd.innerHTML = mozbr;
 				tr.insertBefore(otd, ref);
@@ -255,8 +574,8 @@
 			try {
 				while (range = sel.getRangeAt(i++)) {
 					cell = range.startContainer.childNodes[range.startOffset];
-					while (!/^(td|th|body)$/.test(cell.tagName.toLowerCase())) cell = cell.parentNode;
-					if (/^(td|th)$/.test(cell.tagName.toLowerCase())) cells.push(cell);
+					while (!/^(td|th|body)$/.test(cell.nodeName.toLowerCase())) cell = cell.parentNode;
+					if (/^(td|th)$/.test(cell.nodeName.toLowerCase())) cells.push(cell);
 				}
 			} catch(e) {
 			/* finished walking through selection */
@@ -329,6 +648,7 @@
 			clearRow(otr);
 			otr = tr.parentNode.insertBefore(otr, (/under/.test(buttonId) ? tr.nextSibling : tr));
 			this.editor.selectNodeContents(otr.firstChild, true);
+			this.reStyleTable(tr.parentNode.parentNode);
 			break;
 		    case "TO-row-delete":
 			var tr = this.getClosest("tr");
@@ -344,9 +664,7 @@
 				selectNextNode(tr);
 				part.removeChild(tr);
 			}
-			editor.forceRedraw();
-			editor.focusEditor();
-			editor.updateToolbar();
+			this.reStyleTable(table);
 			break;
 		    case "TO-row-split":
 			var cell = this.getClosest("td");
@@ -359,8 +677,6 @@
 			} else {
 				splitRow(cell);
 			}
-			editor.forceRedraw();
-			editor.updateToolbar();
 			break;
 	
 			// COLUMNS
@@ -379,18 +695,18 @@
 						var tr = rows[i];
 						var ref = tr.cells[index + (/after/.test(buttonId) ? 1 : 0)];
 						if (!ref) {
-							var otd = editor._doc.createElement(tr.lastChild.tagName.toLowerCase());
+							var otd = editor._doc.createElement(tr.lastChild.nodeName.toLowerCase());
 							otd.innerHTML = mozbr;
 							tr.appendChild(otd);
 						} else {
-							var otd = editor._doc.createElement(ref.tagName.toLowerCase());
+							var otd = editor._doc.createElement(ref.nodeName.toLowerCase());
 							otd.innerHTML = mozbr;
 							tr.insertBefore(otd, ref);
 						}
 					}
 				}
 			}
-			editor.focusEditor();
+			this.reStyleTable(table);
 			break;
 		    case "TO-col-split":
 			var cell = this.getClosest("td");
@@ -403,8 +719,7 @@
 			} else {
 				splitCol(cell);
 			}
-			editor.forceRedraw();
-			editor.updateToolbar();
+			this.reStyleTable(table);
 			break;
 		    case "TO-col-delete":
 			var cell = this.getClosest("td");
@@ -443,9 +758,7 @@
 				selectNextNode(table);
 				table.parentNode.removeChild(table);
 			}
-			editor.forceRedraw();
-			editor.focusEditor();
-			editor.updateToolbar();
+			this.reStyleTable(table);
 			break;
 	
 			// CELLS
@@ -460,8 +773,7 @@
 			} else {
 				splitCell(cell);
 			}
-			editor.forceRedraw();
-			editor.updateToolbar();
+			this.reStyleTable(table);
 			break;
 		    case "TO-cell-insert-before":
 		    case "TO-cell-insert-after":
@@ -469,11 +781,10 @@
 			if (!cell) var cell = this.getClosest("th");
 			if (!cell) break;
 			var tr = cell.parentNode;
-			var otd = editor._doc.createElement(cell.tagName.toLowerCase());
+			var otd = editor._doc.createElement(cell.nodeName.toLowerCase());
 			otd.innerHTML = mozbr;
 			tr.insertBefore(otd, (/after/.test(buttonId) ? cell.nextSibling : cell));
-			editor.forceRedraw();
-			editor.focusEditor();
+			this.reStyleTable(tr.parentNode.parentNode);
 			break;
 		    case "TO-cell-delete":
 			var cell = this.getClosest("td");
@@ -496,9 +807,7 @@
 				selectNextNode(cell);
 				row.removeChild(cell);
 			}
-			editor.forceRedraw();
-			editor.focusEditor();
-			editor.updateToolbar();
+			this.reStyleTable(table);
 			break;
 		    case "TO-cell-merge":
 			var sel = editor._getSelection();
@@ -521,7 +830,7 @@
 				} catch(e) {
 					/* finished walking through selection */
 				}
-				rows[tablePartsIndex[row.parentNode.nodeName.toLowerCase()]].push(cells);
+				try { rows[tablePartsIndex[row.parentNode.nodeName.toLowerCase()]].push(cells); } catch(e) { }
 			} else {
 				// Internet Explorer, Safari and Opera
 				var cell = this.getClosest("td");
